<html>
<head>
<title>OgreShaderFunctionAtom.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderFunctionAtom.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderFunctionAtom_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderFunctionAtom_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderFunctionAtom_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderParameter_8h.html">OgreShaderParameter.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 <span class="keyword">namespace </span>RTShader {
<a name="l00038"></a>00038 
<a name="l00048"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html">00048</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html" title="A class that represents an atomic code section of shader based program function.">FunctionAtom</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RTShaderSystemAlloc</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="comment">// Interface.</span>
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00053"></a>00053     <a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html" title="A class that represents an atomic code section of shader based program function.">FunctionAtom</a>            ();
<a name="l00054"></a>00054 
<a name="l00056"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a61addcbea034ca287286963b75290ff5">00056</a>     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a61addcbea034ca287286963b75290ff5" title="Class default destructor.">~FunctionAtom</a>   () {}
<a name="l00057"></a>00057 
<a name="l00059"></a>00059     <span class="keywordtype">int</span>                     getGroupExecutionOrder      () <span class="keyword">const</span>;
<a name="l00060"></a>00060     
<a name="l00062"></a>00062     <span class="keywordtype">int</span>                     getInternalExecutionOrder   () <span class="keyword">const</span>;
<a name="l00063"></a>00063     
<a name="l00065"></a>00065     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            writeSourceCode             (std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; targetLanguage) <span class="keyword">const</span> = 0;
<a name="l00066"></a>00066     
<a name="l00068"></a>00068     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   getFunctionAtomType         () = 0;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 <span class="comment">// Attributes.</span>
<a name="l00071"></a>00071 <span class="keyword">protected</span>:
<a name="l00072"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html#ac336aaa5014552245bf7b1ce1fb6e761">00072</a>     <span class="keywordtype">int</span>         <a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html#ac336aaa5014552245bf7b1ce1fb6e761">mGroupExecutionOrder</a>;       <span class="comment">// The owner group execution order. </span>
<a name="l00073"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a452182d826bf64b754dbb220227e68a2">00073</a>     <span class="keywordtype">int</span>         <a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a452182d826bf64b754dbb220227e68a2">mInternalExecutionOrder</a>;        <span class="comment">// The execution order within the group.        </span>
<a name="l00074"></a>00074 };
<a name="l00075"></a>00075 
<a name="l00078"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html">00078</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RTShaderSystemAlloc</a>
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080 <span class="keyword">public</span>:
<a name="l00081"></a>00081 
<a name="l00082"></a>00082     <span class="comment">// InOut semantic</span>
<a name="l00083"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">00083</a>     <span class="keyword">enum</span> <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">OpSemantic</a>
<a name="l00084"></a>00084     {
<a name="l00086"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7aa06f81dc0c627f8bdf5cc7862a2d41a03">00086</a>         <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7aa06f81dc0c627f8bdf5cc7862a2d41a03" title="The parameter is a input parameter.">OPS_IN</a>, 
<a name="l00088"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7aaa9c91fcd27840fa199f466c9aa479c7a">00088</a>         <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7aaa9c91fcd27840fa199f466c9aa479c7a" title="The parameter is a output parameter.">OPS_OUT</a>,
<a name="l00090"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7aab762072f828e74fe1d0d8f750dedb26d">00090</a>         OPS_INOUT
<a name="l00091"></a>00091     };
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     <span class="comment">// Used field mask</span>
<a name="l00094"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6">00094</a>     <span class="keyword">enum</span> <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6">OpMask</a>
<a name="l00095"></a>00095     {
<a name="l00096"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a88638ec7440dbfc7f63ea80e008cd806">00096</a>         OPM_ALL = 1 &lt;&lt; 0,
<a name="l00097"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a3e3abdcda5f9c9a0745241845d9836fb">00097</a>         OPM_X   = 1 &lt;&lt; 1,
<a name="l00098"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6aaed99f6706ee4fe26faa3525735777c4">00098</a>         OPM_Y   = 1 &lt;&lt; 2,
<a name="l00099"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a8573ab5c28dfe5cc20510abbf77bb078">00099</a>         OPM_Z   = 1 &lt;&lt; 3,
<a name="l00100"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a367b59ffbc3bda50ac3d7fb948b8f2a3">00100</a>         OPM_W   = 1 &lt;&lt; 4
<a name="l00101"></a>00101     };
<a name="l00102"></a>00102 
<a name="l00108"></a>00108     <a class="code" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a>(<a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter, <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">Operand::OpSemantic</a> opSemantic, <span class="keywordtype">int</span> opMask = <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a88638ec7440dbfc7f63ea80e008cd806">Operand::OPM_ALL</a>, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> indirectionLevel = 0);
<a name="l00109"></a>00109 
<a name="l00111"></a>00111     <a class="code" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a>&amp; rhs);
<a name="l00112"></a>00112 
<a name="l00116"></a>00116     <a class="code" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a>&amp; operator= (<span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a> &amp; rhs);
<a name="l00117"></a>00117 
<a name="l00119"></a>00119     ~<a class="code" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a>();
<a name="l00120"></a>00120 
<a name="l00122"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a442fef6f47459a1b980aac782555d45d">00122</a>     <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>&amp; <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a442fef6f47459a1b980aac782555d45d" title="Returns the parameter object as weak reference.">getParameter</a>    ()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> mParameter; }
<a name="l00123"></a>00123 
<a name="l00125"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a691e3080ac0ede4822951f55d4a718b0">00125</a>     <span class="keywordtype">bool</span>                <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a691e3080ac0ede4822951f55d4a718b0" title="Returns true if not all fields used.">hasFreeFields</a>   ()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> ((mMask &amp; ~OPM_ALL) &amp;&amp; ((mMask &amp; ~OPM_X) || (mMask &amp; ~OPM_Y) || (mMask &amp; ~OPM_Z) || (mMask &amp; ~OPM_W))); }
<a name="l00126"></a>00126     
<a name="l00128"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#aa2566f52ef780d2db721c77d7fcdd32f">00128</a>     <span class="keywordtype">int</span>                 <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#aa2566f52ef780d2db721c77d7fcdd32f" title="Returns the mask bitfield.">getMask</a>         ()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> mMask; }
<a name="l00129"></a>00129 
<a name="l00131"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#acd606928c7dcba7ed43058ee4c1b361f">00131</a>     <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">OpSemantic</a>          <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#acd606928c7dcba7ed43058ee4c1b361f" title="Returns the operand semantic (do we read/write or both with the parameter).">getSemantic</a>     ()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> mSemantic; }
<a name="l00132"></a>00132 
<a name="l00138"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#ae2c64f2cd91742f9d87569d6c001f5ef">00138</a>     <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>              <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#ae2c64f2cd91742f9d87569d6c001f5ef" title="Returns the level of indirection.">getIndirectionLevel</a>()<span class="keyword">   const </span>{ <span class="keywordflow">return</span> mIndirectionLevel; }
<a name="l00139"></a>00139 
<a name="l00141"></a>00141     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>              toString        ()  <span class="keyword">const</span>;
<a name="l00142"></a>00142 
<a name="l00144"></a>00144     <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>               getMaskAsString     (<span class="keywordtype">int</span> mask);
<a name="l00145"></a>00145 
<a name="l00147"></a>00147     <span class="keyword">static</span> <span class="keywordtype">int</span>                  getFloatCount       (<span class="keywordtype">int</span> mask);
<a name="l00148"></a>00148 
<a name="l00150"></a>00150     <span class="keyword">static</span> <a class="code" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447" title="Enumeration of the types of constant we may encounter in programs.">GpuConstantType</a>      getGpuConstantType  (<span class="keywordtype">int</span> mask);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="keyword">protected</span>:
<a name="l00153"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#ac4a9c9955226d83dc5cb549ad4428b54">00153</a>     <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a>    <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#ac4a9c9955226d83dc5cb549ad4428b54">mParameter</a>;         
<a name="l00154"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a2c7730bd7b91343e449de81d45c33eda">00154</a>     <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">OpSemantic</a>      <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a2c7730bd7b91343e449de81d45c33eda" title="The parameter being carried by the operand.">mSemantic</a>;          
<a name="l00155"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#aac755a994405d1ac3e3777898b0fb407">00155</a>     <span class="keywordtype">int</span>             <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#aac755a994405d1ac3e3777898b0fb407" title="Tells if the parameter is of type input,output or both.">mMask</a>;              
<a name="l00156"></a><a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a14fd9b8061396b69d145128f42b57269">00156</a>     <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>          <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a14fd9b8061396b69d145128f42b57269" title="Which part of the parameter should be passed (x,y,z,w)">mIndirectionLevel</a>;  
<a name="l00157"></a>00157 };
<a name="l00158"></a>00158 
<a name="l00161"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">00161</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RTShader_1_1FunctionAtom.html" title="A class that represents an atomic code section of shader based program function.">FunctionAtom</a>
<a name="l00162"></a>00162 {
<a name="l00163"></a>00163     <span class="comment">// Interface.</span>
<a name="l00164"></a>00164 <span class="keyword">public</span>: 
<a name="l00165"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a709fbe496a60e5c9568461c236b4fa26">00165</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Operand&gt;::type</a> <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a709fbe496a60e5c9568461c236b4fa26">OperandVector</a>;
<a name="l00166"></a>00166 
<a name="l00173"></a>00173     <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; functionName, <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span> internalOrder, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> returnType = <span class="stringliteral">&quot;void&quot;</span>);
<a name="l00174"></a>00174 
<a name="l00176"></a>00176     <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a>&amp; rhs);
<a name="l00177"></a>00177 
<a name="l00181"></a>00181     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            writeSourceCode (std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; targetLanguage) <span class="keyword">const</span>;
<a name="l00182"></a>00182 
<a name="l00186"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a5d5fb412bf05e9c04d7a9084fdeef9c7">00186</a>     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a5d5fb412bf05e9c04d7a9084fdeef9c7">getFunctionAtomType</a> () { <span class="keywordflow">return</span> Type; }
<a name="l00187"></a>00187 
<a name="l00189"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a9e9e5dd69fd84e4c67b89605bc608f4e">00189</a>     <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a709fbe496a60e5c9568461c236b4fa26">OperandVector</a>&amp;          <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a9e9e5dd69fd84e4c67b89605bc608f4e" title="Get a list of parameters this function invocation will use in the function call as arguments...">getOperandList</a>  () { <span class="keywordflow">return</span> mOperands; }
<a name="l00190"></a>00190     
<a name="l00197"></a>00197     <span class="keywordtype">void</span>                    pushOperand(<a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter, <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">Operand::OpSemantic</a> opSemantic, <span class="keywordtype">int</span> opMask = <a class="code" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a88638ec7440dbfc7f63ea80e008cd806">Operand::OPM_ALL</a>, <span class="keywordtype">int</span> indirectionLevel = 0);
<a name="l00198"></a>00198 
<a name="l00200"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#ac59d6c18ad1b47e6748b173ccd8c9d0f">00200</a>     <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;           <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#ac59d6c18ad1b47e6748b173ccd8c9d0f" title="Return the function name.">getFunctionName</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFunctionName; }
<a name="l00201"></a>00201 
<a name="l00203"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a7025e33c39fe3126043a769321118b36">00203</a>     <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;           <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a7025e33c39fe3126043a769321118b36" title="Return the return type.">getReturnType</a>   ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mReturnType; }
<a name="l00204"></a>00204 
<a name="l00206"></a>00206     <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator == </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a>&amp; rhs ) <span class="keyword">const</span>;
<a name="l00207"></a>00207 
<a name="l00209"></a>00209     <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator != </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a>&amp; rhs ) <span class="keyword">const</span>;
<a name="l00210"></a>00210 
<a name="l00212"></a>00212     <span class="keywordtype">bool</span> <a class="code" href="group__General.html#gae1dbf4506ab2500da5ec4ef0b58cb2e1">operator &lt;  </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a>&amp; rhs ) <span class="keyword">const</span>;
<a name="l00213"></a>00213 
<a name="l00217"></a><a class="code" href="structOgre_1_1RTShader_1_1FunctionInvocation_1_1FunctionInvocationLessThan.html">00217</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1RTShader_1_1FunctionInvocation_1_1FunctionInvocationLessThan.html" title="Comparator function to be used for sorting.">FunctionInvocationLessThan</a>
<a name="l00218"></a>00218     {
<a name="l00219"></a>00219         <span class="keywordtype">bool</span> operator ()(<a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a> <span class="keyword">const</span>&amp; lhs, <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a> <span class="keyword">const</span>&amp; rhs) <span class="keyword">const</span>;
<a name="l00220"></a>00220     };
<a name="l00221"></a>00221 
<a name="l00225"></a><a class="code" href="structOgre_1_1RTShader_1_1FunctionInvocation_1_1FunctionInvocationCompare.html">00225</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1RTShader_1_1FunctionInvocation_1_1FunctionInvocationCompare.html" title="Comparator function to be used for comparisons.">FunctionInvocationCompare</a>
<a name="l00226"></a>00226     {
<a name="l00227"></a>00227         <span class="keywordtype">bool</span> operator ()(<a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a> <span class="keyword">const</span>&amp; lhs, <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a> <span class="keyword">const</span>&amp; rhs) <span class="keyword">const</span>;
<a name="l00228"></a>00228     };
<a name="l00229"></a>00229 
<a name="l00231"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#aaae61702cada22f742ffd7f26d56c723">00231</a>     <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#aaae61702cada22f742ffd7f26d56c723" title="The type of this class.">Type</a>;
<a name="l00232"></a>00232 
<a name="l00233"></a>00233     <span class="comment">// Attributes.</span>
<a name="l00234"></a>00234 <span class="keyword">protected</span>:  
<a name="l00235"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a42c43ab09ddc59f82be80c525d38a3c6">00235</a>     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>              <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a42c43ab09ddc59f82be80c525d38a3c6">mFunctionName</a>;
<a name="l00236"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#ad7a2d9fefa8e5048587b2669b5254470">00236</a>     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>              <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#ad7a2d9fefa8e5048587b2669b5254470">mReturnType</a>;
<a name="l00237"></a><a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#abcff7ec674637ae18bd18a890130f975">00237</a>     <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a709fbe496a60e5c9568461c236b4fa26">OperandVector</a>       <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#abcff7ec674637ae18bd18a890130f975">mOperands</a>;  
<a name="l00238"></a>00238 };
<a name="l00239"></a>00239 
<a name="l00240"></a><a class="code" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">00240</a> <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;FunctionAtom*&gt;::type</a>                 <a class="code" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">FunctionAtomInstanceList</a>;
<a name="l00241"></a><a class="code" href="group__RTShader.html#ga93c3d79b3386560226545b89126d507c">00241</a> <span class="keyword">typedef</span> FunctionAtomInstanceList::iterator          <a class="code" href="group__RTShader.html#ga93c3d79b3386560226545b89126d507c">FunctionAtomInstanceIterator</a>;
<a name="l00242"></a><a class="code" href="group__RTShader.html#gaac0a5ca5463f1d828d1c29d396e58e31">00242</a> <span class="keyword">typedef</span> FunctionAtomInstanceList::const_iterator    <a class="code" href="group__RTShader.html#gaac0a5ca5463f1d828d1c29d396e58e31">FunctionAtomInstanceConstIterator</a>;
<a name="l00243"></a>00243 
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
